Flutter에서 토스페이먼츠 결제창을 손쉽게 연동하기 위한 패키지입니다.

## 1. 사전 설정

### A. Android 설정
usesCleartextTraffic 세팅을 true로 설정하여, 웹뷰 내 모든 카드사앱을 띄울 수 있도록 설정
```xml
...
<appication ...  android:usesCleartextTraffic="true"></application>
...
```


### B. iOS설정
별도 설정할 내용 없음


## 2. 시작하기
아래 방법으로 토스페이먼츠 결제창을 띄울 수 있습니다. 자세한 내용은 예제(example)을 참고해주세요.

```dart
import 'package:flutter/material.dart';
import 'package:tosspayments_official/tosspayments_official.dart';
import 'package:tosspayments_official/model/paymentData.dart';
class Payment extends StatelessWidget {
  @override
  Widget build(BuildContext context) {
    return TossPayments(
      appBar: AppBar(
        title: const Text('결제하기'),
        centerTitle: true,
        leading: IconButton(
          icon: const Icon(Icons.arrow_back_ios),
          onPressed: () {
            Get.back();
          },
        ),
      ),
      initialChild: SafeArea(
        child: Center(
          child: Column(
            mainAxisAlignment: MainAxisAlignment.center,
            children: const [
              Text('Loading...', style: TextStyle(fontSize: 18)),
            ],
          ),
        ),
      ),
      apiKey: ##TODO clientKey 입력 ##,
      data:  PaymentData(
          paymentMethod: '카드',
          orderId: 'tosspayments-202303210239',
          orderName: 'toss t-shirt',
          amount: 50000,
          customerName: '김토스',
          customerEmail: 'toss@toss-payments.co.kr'
      ),
      callback: (Map<String, String> result) {
        Navigator.pushReplacementNamed( context, '/result', arguments: result,);
      },
    );
  }
}

```

