import 'package:flutter/material.dart';
import 'package:get/get.dart';

class Result extends StatelessWidget {

  bool getIsSuccessed(Map<String, String> result) {
    if (result['message'] != null) {
      return false;
    }
    return true;
  }

  @override
  Widget build(BuildContext context) {
    Map<String, String> result = Get.arguments as Map<String, String>;
    bool isSuccessed = getIsSuccessed(result);
    String message;

    if (isSuccessed) {
      message = '인증 성공! 결제승인API를 호출해 결제를 완료하세요!';
    } else {
      message = '결제에 실패하였습니다';

    }
    return Scaffold(
        appBar: AppBar(
          title: Text('결제 결과'),
          centerTitle: true,
          automaticallyImplyLeading: false,
        ),
        body: SafeArea(
          child: Container(
            padding: const EdgeInsets.fromLTRB(30, 30, 30, 50),
            child: Column(
              mainAxisAlignment: MainAxisAlignment.center,
              children: [
                Text(
                  message,
                  style: const TextStyle(
                    fontWeight: FontWeight.bold,
                    fontSize: 20,
                  ),
                ),
                const SizedBox(height: 50),
                isSuccessed
                    ? Container(
                  child: Column(
                    children: <Widget>[
                      Row(
                        children: [
                          const Expanded(
                              flex: 3,
                              child: Text('orderId',
                                  style: TextStyle(color: Colors.grey))),
                          Expanded(
                            flex: 8,
                            child: Text(result['orderId'] ?? '-'),
                          ),
                        ],
                      ),
                      const SizedBox(height: 20),
                      Row(
                        children: [
                          const Expanded(
                              flex: 3,
                              child: Text('paymentKey',
                                  style: TextStyle(color: Colors.grey))),
                          Expanded(
                            flex: 8,
                            child: Text(result['paymentKey'] ?? '-'),
                          ),
                        ],
                      ),
                      const SizedBox(height: 20),

                      Row(
                        children: [
                          const Expanded(
                              flex: 3,
                              child: Text('amount',
                                  style: TextStyle(color: Colors.grey))),
                          Expanded(
                            flex: 8,
                            child: Text(result['amount'] ?? '-'),
                          ),
                        ],
                      ),

                    ],
                  ),
                )
                    : Container(
                  padding: EdgeInsets.symmetric(vertical: 5),
                  child: Row(
                    mainAxisAlignment: MainAxisAlignment.start,
                    children: [
                      const Expanded(
                        flex: 4,
                        child: Text('에러 메시지',
                            style: TextStyle(color: Colors.grey)),
                      ),
                      Expanded(
                        flex: 5,
                        child: Text(result['message'] ?? '-'),
                      ),
                    ],
                  ),
                ),
                const SizedBox(height: 40),
                ElevatedButton.icon(
                  icon: const Icon(Icons.home),
                  onPressed: () {
                    Get.offAllNamed('/');
                  },
                  label: const Text(
                    '홈으로',
                    style: TextStyle(fontSize: 16, color: Colors.white),
                  ),
                  style: ElevatedButton.styleFrom(
                    elevation: 0,
                    shadowColor: Colors.transparent,
                  ),
                ),
              ],
            ),
          ),
        )
    );
  }
}
