library tosspayments_sdk_flutter;

import 'dart:convert';
import 'package:flutter/cupertino.dart';
import 'package:flutter/foundation.dart';
import 'package:flutter/gestures.dart';
import 'package:flutter/material.dart';
import 'package:tosspayments_sdk_flutter/model/paymentData.dart';
import 'package:tosspayments_sdk_flutter/widget/payment_window_webview.dart';
import 'package:webview_flutter/webview_flutter.dart';

class TossPayments extends StatelessWidget {
  final PreferredSizeWidget? appBar;
  final Widget? initialChild;
  final String apiKey;
  final PaymentData data;
  final callback;
  final Set<Factory<OneSequenceGestureRecognizer>>? gestureRecognizers;

  TossPayments({
    Key? key,
    this.appBar,
    this.initialChild,
    required this.apiKey,
    required this.data,
    required this.callback,
    this.gestureRecognizers,
  }) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return TosspaymentsWebview(
      type: ActionType.payment,
      appBar: appBar,
      initialChild: initialChild,
      executeJS: (WebViewController controller) {
        controller.runJavascript('''
          var clientKey = '$apiKey';
          var tossPayments = TossPayments(clientKey);
          tossPayments.requestPayment('${data.paymentMethod}', ${jsonEncode(data.toJson())});
          ''');
      },
      getQueryParams: (Map<String, String> data) {
        callback(data);
      },
      ifAuthDone: (String url) {
        if (url.startsWith("tosspayments://")) {
          return true;
        }

        // 실패했을 때
        return false;
      },
    );
  }
}